// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlCommand.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_platform_msgs/msg/adaptive_cruise_control_command.hpp"


#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_COMMAND__TRAITS_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_COMMAND__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "automotive_platform_msgs/msg/detail/adaptive_cruise_control_command__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace automotive_platform_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AdaptiveCruiseControlCommand & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: msg_counter
  {
    out << "msg_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.msg_counter, out);
    out << ", ";
  }

  // member: set_speed
  {
    out << "set_speed: ";
    rosidl_generator_traits::value_to_yaml(msg.set_speed, out);
    out << ", ";
  }

  // member: set
  {
    out << "set: ";
    rosidl_generator_traits::value_to_yaml(msg.set, out);
    out << ", ";
  }

  // member: resume
  {
    out << "resume: ";
    rosidl_generator_traits::value_to_yaml(msg.resume, out);
    out << ", ";
  }

  // member: cancel
  {
    out << "cancel: ";
    rosidl_generator_traits::value_to_yaml(msg.cancel, out);
    out << ", ";
  }

  // member: speed_up
  {
    out << "speed_up: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_up, out);
    out << ", ";
  }

  // member: slow_down
  {
    out << "slow_down: ";
    rosidl_generator_traits::value_to_yaml(msg.slow_down, out);
    out << ", ";
  }

  // member: further
  {
    out << "further: ";
    rosidl_generator_traits::value_to_yaml(msg.further, out);
    out << ", ";
  }

  // member: closer
  {
    out << "closer: ";
    rosidl_generator_traits::value_to_yaml(msg.closer, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AdaptiveCruiseControlCommand & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: msg_counter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "msg_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.msg_counter, out);
    out << "\n";
  }

  // member: set_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "set_speed: ";
    rosidl_generator_traits::value_to_yaml(msg.set_speed, out);
    out << "\n";
  }

  // member: set
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "set: ";
    rosidl_generator_traits::value_to_yaml(msg.set, out);
    out << "\n";
  }

  // member: resume
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "resume: ";
    rosidl_generator_traits::value_to_yaml(msg.resume, out);
    out << "\n";
  }

  // member: cancel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cancel: ";
    rosidl_generator_traits::value_to_yaml(msg.cancel, out);
    out << "\n";
  }

  // member: speed_up
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_up: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_up, out);
    out << "\n";
  }

  // member: slow_down
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "slow_down: ";
    rosidl_generator_traits::value_to_yaml(msg.slow_down, out);
    out << "\n";
  }

  // member: further
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "further: ";
    rosidl_generator_traits::value_to_yaml(msg.further, out);
    out << "\n";
  }

  // member: closer
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "closer: ";
    rosidl_generator_traits::value_to_yaml(msg.closer, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AdaptiveCruiseControlCommand & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace automotive_platform_msgs

namespace rosidl_generator_traits
{

[[deprecated("use automotive_platform_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const automotive_platform_msgs::msg::AdaptiveCruiseControlCommand & msg,
  std::ostream & out, size_t indentation = 0)
{
  automotive_platform_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use automotive_platform_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const automotive_platform_msgs::msg::AdaptiveCruiseControlCommand & msg)
{
  return automotive_platform_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand>()
{
  return "automotive_platform_msgs::msg::AdaptiveCruiseControlCommand";
}

template<>
inline const char * name<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand>()
{
  return "automotive_platform_msgs/msg/AdaptiveCruiseControlCommand";
}

template<>
struct has_fixed_size<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_COMMAND__TRAITS_HPP_
