// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from automotive_platform_msgs:msg/CabinReport.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_platform_msgs/msg/cabin_report.hpp"


#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__BUILDER_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "automotive_platform_msgs/msg/detail/cabin_report__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace automotive_platform_msgs
{

namespace msg
{

namespace builder
{

class Init_CabinReport_seatbelt_engaged_passenger
{
public:
  explicit Init_CabinReport_seatbelt_engaged_passenger(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  ::automotive_platform_msgs::msg::CabinReport seatbelt_engaged_passenger(::automotive_platform_msgs::msg::CabinReport::_seatbelt_engaged_passenger_type arg)
  {
    msg_.seatbelt_engaged_passenger = std::move(arg);
    return std::move(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_seatbelt_engaged_driver
{
public:
  explicit Init_CabinReport_seatbelt_engaged_driver(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_seatbelt_engaged_passenger seatbelt_engaged_driver(::automotive_platform_msgs::msg::CabinReport::_seatbelt_engaged_driver_type arg)
  {
    msg_.seatbelt_engaged_driver = std::move(arg);
    return Init_CabinReport_seatbelt_engaged_passenger(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_passenger_airbag_enabled
{
public:
  explicit Init_CabinReport_passenger_airbag_enabled(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_seatbelt_engaged_driver passenger_airbag_enabled(::automotive_platform_msgs::msg::CabinReport::_passenger_airbag_enabled_type arg)
  {
    msg_.passenger_airbag_enabled = std::move(arg);
    return Init_CabinReport_seatbelt_engaged_driver(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_passenger_present
{
public:
  explicit Init_CabinReport_passenger_present(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_passenger_airbag_enabled passenger_present(::automotive_platform_msgs::msg::CabinReport::_passenger_present_type arg)
  {
    msg_.passenger_present = std::move(arg);
    return Init_CabinReport_passenger_airbag_enabled(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_trunk_open
{
public:
  explicit Init_CabinReport_trunk_open(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_passenger_present trunk_open(::automotive_platform_msgs::msg::CabinReport::_trunk_open_type arg)
  {
    msg_.trunk_open = std::move(arg);
    return Init_CabinReport_passenger_present(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_hood_open
{
public:
  explicit Init_CabinReport_hood_open(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_trunk_open hood_open(::automotive_platform_msgs::msg::CabinReport::_hood_open_type arg)
  {
    msg_.hood_open = std::move(arg);
    return Init_CabinReport_trunk_open(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_door_open_rear_left
{
public:
  explicit Init_CabinReport_door_open_rear_left(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_hood_open door_open_rear_left(::automotive_platform_msgs::msg::CabinReport::_door_open_rear_left_type arg)
  {
    msg_.door_open_rear_left = std::move(arg);
    return Init_CabinReport_hood_open(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_door_open_rear_right
{
public:
  explicit Init_CabinReport_door_open_rear_right(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_door_open_rear_left door_open_rear_right(::automotive_platform_msgs::msg::CabinReport::_door_open_rear_right_type arg)
  {
    msg_.door_open_rear_right = std::move(arg);
    return Init_CabinReport_door_open_rear_left(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_door_open_front_left
{
public:
  explicit Init_CabinReport_door_open_front_left(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_door_open_rear_right door_open_front_left(::automotive_platform_msgs::msg::CabinReport::_door_open_front_left_type arg)
  {
    msg_.door_open_front_left = std::move(arg);
    return Init_CabinReport_door_open_rear_right(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_door_open_front_right
{
public:
  explicit Init_CabinReport_door_open_front_right(::automotive_platform_msgs::msg::CabinReport & msg)
  : msg_(msg)
  {}
  Init_CabinReport_door_open_front_left door_open_front_right(::automotive_platform_msgs::msg::CabinReport::_door_open_front_right_type arg)
  {
    msg_.door_open_front_right = std::move(arg);
    return Init_CabinReport_door_open_front_left(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

class Init_CabinReport_header
{
public:
  Init_CabinReport_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_CabinReport_door_open_front_right header(::automotive_platform_msgs::msg::CabinReport::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_CabinReport_door_open_front_right(msg_);
  }

private:
  ::automotive_platform_msgs::msg::CabinReport msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::automotive_platform_msgs::msg::CabinReport>()
{
  return automotive_platform_msgs::msg::builder::Init_CabinReport_header();
}

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__BUILDER_HPP_
