// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_platform_msgs:msg/CabinReport.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_platform_msgs/msg/cabin_report.hpp"


#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__TRAITS_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "automotive_platform_msgs/msg/detail/cabin_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace automotive_platform_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const CabinReport & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: door_open_front_right
  {
    out << "door_open_front_right: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_front_right, out);
    out << ", ";
  }

  // member: door_open_front_left
  {
    out << "door_open_front_left: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_front_left, out);
    out << ", ";
  }

  // member: door_open_rear_right
  {
    out << "door_open_rear_right: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_rear_right, out);
    out << ", ";
  }

  // member: door_open_rear_left
  {
    out << "door_open_rear_left: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_rear_left, out);
    out << ", ";
  }

  // member: hood_open
  {
    out << "hood_open: ";
    rosidl_generator_traits::value_to_yaml(msg.hood_open, out);
    out << ", ";
  }

  // member: trunk_open
  {
    out << "trunk_open: ";
    rosidl_generator_traits::value_to_yaml(msg.trunk_open, out);
    out << ", ";
  }

  // member: passenger_present
  {
    out << "passenger_present: ";
    rosidl_generator_traits::value_to_yaml(msg.passenger_present, out);
    out << ", ";
  }

  // member: passenger_airbag_enabled
  {
    out << "passenger_airbag_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.passenger_airbag_enabled, out);
    out << ", ";
  }

  // member: seatbelt_engaged_driver
  {
    out << "seatbelt_engaged_driver: ";
    rosidl_generator_traits::value_to_yaml(msg.seatbelt_engaged_driver, out);
    out << ", ";
  }

  // member: seatbelt_engaged_passenger
  {
    out << "seatbelt_engaged_passenger: ";
    rosidl_generator_traits::value_to_yaml(msg.seatbelt_engaged_passenger, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CabinReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: door_open_front_right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "door_open_front_right: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_front_right, out);
    out << "\n";
  }

  // member: door_open_front_left
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "door_open_front_left: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_front_left, out);
    out << "\n";
  }

  // member: door_open_rear_right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "door_open_rear_right: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_rear_right, out);
    out << "\n";
  }

  // member: door_open_rear_left
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "door_open_rear_left: ";
    rosidl_generator_traits::value_to_yaml(msg.door_open_rear_left, out);
    out << "\n";
  }

  // member: hood_open
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hood_open: ";
    rosidl_generator_traits::value_to_yaml(msg.hood_open, out);
    out << "\n";
  }

  // member: trunk_open
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "trunk_open: ";
    rosidl_generator_traits::value_to_yaml(msg.trunk_open, out);
    out << "\n";
  }

  // member: passenger_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "passenger_present: ";
    rosidl_generator_traits::value_to_yaml(msg.passenger_present, out);
    out << "\n";
  }

  // member: passenger_airbag_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "passenger_airbag_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.passenger_airbag_enabled, out);
    out << "\n";
  }

  // member: seatbelt_engaged_driver
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "seatbelt_engaged_driver: ";
    rosidl_generator_traits::value_to_yaml(msg.seatbelt_engaged_driver, out);
    out << "\n";
  }

  // member: seatbelt_engaged_passenger
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "seatbelt_engaged_passenger: ";
    rosidl_generator_traits::value_to_yaml(msg.seatbelt_engaged_passenger, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CabinReport & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace automotive_platform_msgs

namespace rosidl_generator_traits
{

[[deprecated("use automotive_platform_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const automotive_platform_msgs::msg::CabinReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  automotive_platform_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use automotive_platform_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const automotive_platform_msgs::msg::CabinReport & msg)
{
  return automotive_platform_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<automotive_platform_msgs::msg::CabinReport>()
{
  return "automotive_platform_msgs::msg::CabinReport";
}

template<>
inline const char * name<automotive_platform_msgs::msg::CabinReport>()
{
  return "automotive_platform_msgs/msg/CabinReport";
}

template<>
struct has_fixed_size<automotive_platform_msgs::msg::CabinReport>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<automotive_platform_msgs::msg::CabinReport>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<automotive_platform_msgs::msg::CabinReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__TRAITS_HPP_
