// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_platform_msgs:msg/DriverCommands.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_platform_msgs/msg/driver_commands.h"


#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__STRUCT_H_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Struct defined in msg/DriverCommands in the package automotive_platform_msgs.
/**
  * Driver Commands Message
  * Contains commands from the driver to the autonomy system
 */
typedef struct automotive_platform_msgs__msg__DriverCommands
{
  /// Increments each time a command is sent
  /// An acknowledge message should be published with this value
  uint8_t msg_counter;
  /// Engage auto
  uint16_t engage;
  /// Disengage auto
  uint16_t disengage;
  /// Increase speed set point
  uint16_t speed_up;
  /// Decrease speed set point
  uint16_t slow_down;
  /// Increase distance set point
  uint16_t further;
  /// Decrease distance set point
  uint16_t closer;
  /// Right turn signal
  uint16_t right_turn;
  /// Left turn signal
  uint16_t left_turn;
} automotive_platform_msgs__msg__DriverCommands;

// Struct for a sequence of automotive_platform_msgs__msg__DriverCommands.
typedef struct automotive_platform_msgs__msg__DriverCommands__Sequence
{
  automotive_platform_msgs__msg__DriverCommands * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} automotive_platform_msgs__msg__DriverCommands__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__STRUCT_H_
