// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_platform_msgs:msg/SpeedMode.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_platform_msgs/msg/speed_mode.h"


#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED_MODE__STRUCT_H_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED_MODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/SpeedMode in the package automotive_platform_msgs.
/**
  * Speed Control Message with Mode
  * Contains speed commands and desired autonomy active mode flag
 */
typedef struct automotive_platform_msgs__msg__SpeedMode
{
  std_msgs__msg__Header header;
  /// Is 1 if autonomy mode should be active
  uint16_t mode;
  /// Desired speed (m/sec)
  float speed;
  /// Max acceleration limit (m/sec^2)
  float acceleration_limit;
  /// Max deceleration limit (m/sec^2)
  float deceleration_limit;
} automotive_platform_msgs__msg__SpeedMode;

// Struct for a sequence of automotive_platform_msgs__msg__SpeedMode.
typedef struct automotive_platform_msgs__msg__SpeedMode__Sequence
{
  automotive_platform_msgs__msg__SpeedMode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} automotive_platform_msgs__msg__SpeedMode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED_MODE__STRUCT_H_
