// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/CabinReport.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/cabin_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
automotive_platform_msgs__msg__CabinReport__init(automotive_platform_msgs__msg__CabinReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__CabinReport__fini(msg);
    return false;
  }
  // door_open_front_right
  // door_open_front_left
  // door_open_rear_right
  // door_open_rear_left
  // hood_open
  // trunk_open
  // passenger_present
  // passenger_airbag_enabled
  // seatbelt_engaged_driver
  // seatbelt_engaged_passenger
  return true;
}

void
automotive_platform_msgs__msg__CabinReport__fini(automotive_platform_msgs__msg__CabinReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // door_open_front_right
  // door_open_front_left
  // door_open_rear_right
  // door_open_rear_left
  // hood_open
  // trunk_open
  // passenger_present
  // passenger_airbag_enabled
  // seatbelt_engaged_driver
  // seatbelt_engaged_passenger
}

bool
automotive_platform_msgs__msg__CabinReport__are_equal(const automotive_platform_msgs__msg__CabinReport * lhs, const automotive_platform_msgs__msg__CabinReport * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // door_open_front_right
  if (lhs->door_open_front_right != rhs->door_open_front_right) {
    return false;
  }
  // door_open_front_left
  if (lhs->door_open_front_left != rhs->door_open_front_left) {
    return false;
  }
  // door_open_rear_right
  if (lhs->door_open_rear_right != rhs->door_open_rear_right) {
    return false;
  }
  // door_open_rear_left
  if (lhs->door_open_rear_left != rhs->door_open_rear_left) {
    return false;
  }
  // hood_open
  if (lhs->hood_open != rhs->hood_open) {
    return false;
  }
  // trunk_open
  if (lhs->trunk_open != rhs->trunk_open) {
    return false;
  }
  // passenger_present
  if (lhs->passenger_present != rhs->passenger_present) {
    return false;
  }
  // passenger_airbag_enabled
  if (lhs->passenger_airbag_enabled != rhs->passenger_airbag_enabled) {
    return false;
  }
  // seatbelt_engaged_driver
  if (lhs->seatbelt_engaged_driver != rhs->seatbelt_engaged_driver) {
    return false;
  }
  // seatbelt_engaged_passenger
  if (lhs->seatbelt_engaged_passenger != rhs->seatbelt_engaged_passenger) {
    return false;
  }
  return true;
}

bool
automotive_platform_msgs__msg__CabinReport__copy(
  const automotive_platform_msgs__msg__CabinReport * input,
  automotive_platform_msgs__msg__CabinReport * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // door_open_front_right
  output->door_open_front_right = input->door_open_front_right;
  // door_open_front_left
  output->door_open_front_left = input->door_open_front_left;
  // door_open_rear_right
  output->door_open_rear_right = input->door_open_rear_right;
  // door_open_rear_left
  output->door_open_rear_left = input->door_open_rear_left;
  // hood_open
  output->hood_open = input->hood_open;
  // trunk_open
  output->trunk_open = input->trunk_open;
  // passenger_present
  output->passenger_present = input->passenger_present;
  // passenger_airbag_enabled
  output->passenger_airbag_enabled = input->passenger_airbag_enabled;
  // seatbelt_engaged_driver
  output->seatbelt_engaged_driver = input->seatbelt_engaged_driver;
  // seatbelt_engaged_passenger
  output->seatbelt_engaged_passenger = input->seatbelt_engaged_passenger;
  return true;
}

automotive_platform_msgs__msg__CabinReport *
automotive_platform_msgs__msg__CabinReport__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__CabinReport * msg = (automotive_platform_msgs__msg__CabinReport *)allocator.allocate(sizeof(automotive_platform_msgs__msg__CabinReport), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__CabinReport));
  bool success = automotive_platform_msgs__msg__CabinReport__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__CabinReport__destroy(automotive_platform_msgs__msg__CabinReport * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_platform_msgs__msg__CabinReport__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_platform_msgs__msg__CabinReport__Sequence__init(automotive_platform_msgs__msg__CabinReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__CabinReport * data = NULL;

  if (size) {
    data = (automotive_platform_msgs__msg__CabinReport *)allocator.zero_allocate(size, sizeof(automotive_platform_msgs__msg__CabinReport), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__CabinReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__CabinReport__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__CabinReport__Sequence__fini(automotive_platform_msgs__msg__CabinReport__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__CabinReport__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__CabinReport__Sequence *
automotive_platform_msgs__msg__CabinReport__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__CabinReport__Sequence * array = (automotive_platform_msgs__msg__CabinReport__Sequence *)allocator.allocate(sizeof(automotive_platform_msgs__msg__CabinReport__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__CabinReport__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__CabinReport__Sequence__destroy(automotive_platform_msgs__msg__CabinReport__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_platform_msgs__msg__CabinReport__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_platform_msgs__msg__CabinReport__Sequence__are_equal(const automotive_platform_msgs__msg__CabinReport__Sequence * lhs, const automotive_platform_msgs__msg__CabinReport__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_platform_msgs__msg__CabinReport__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_platform_msgs__msg__CabinReport__Sequence__copy(
  const automotive_platform_msgs__msg__CabinReport__Sequence * input,
  automotive_platform_msgs__msg__CabinReport__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_platform_msgs__msg__CabinReport);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    automotive_platform_msgs__msg__CabinReport * data =
      (automotive_platform_msgs__msg__CabinReport *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_platform_msgs__msg__CabinReport__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          automotive_platform_msgs__msg__CabinReport__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_platform_msgs__msg__CabinReport__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
