// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_platform_msgs:msg/CabinReport.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_platform_msgs/msg/cabin_report.h"


#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__STRUCT_H_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/CabinReport in the package automotive_platform_msgs.
/**
  * Status of vehicle cabin sensors
 */
typedef struct automotive_platform_msgs__msg__CabinReport
{
  std_msgs__msg__Header header;
  /// The door positions below are from the point of view of someone sitting
  /// in the vehicle, facing the X positive direction. Not using driver/passenger
  /// since this is different in left- vs right-hand drive vehicles.
  /// Status of the door nearest the front of the vehicle in the Y+ direction
  bool door_open_front_right;
  /// Status of the door nearest the front of the vehicle in the Y- direction
  bool door_open_front_left;
  /// Status of the door nearest the rear of the vehicle in the Y+ direction
  bool door_open_rear_right;
  /// Status of the door nearest the rear of the vehicle in the Y- direction
  bool door_open_rear_left;
  /// Status of the front compartment cover
  bool hood_open;
  /// Status of the rear compartment cover
  bool trunk_open;
  /// Whether or not a passenger is detected in the front non-driving seat
  bool passenger_present;
  /// Whether or not the passenger-side airbag is enabled
  bool passenger_airbag_enabled;
  /// Whether or not the seatbelt for the driver's seat is buckled
  bool seatbelt_engaged_driver;
  /// Whether or not the seatbelt for the passenger's seat is buckled
  bool seatbelt_engaged_passenger;
} automotive_platform_msgs__msg__CabinReport;

// Struct for a sequence of automotive_platform_msgs__msg__CabinReport.
typedef struct automotive_platform_msgs__msg__CabinReport__Sequence
{
  automotive_platform_msgs__msg__CabinReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} automotive_platform_msgs__msg__CabinReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__CABIN_REPORT__STRUCT_H_
