// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from automotive_platform_msgs:msg/DriverCommands.idl
// generated code does not contain a copyright notice

#include "automotive_platform_msgs/msg/detail/driver_commands__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
const rosidl_type_hash_t *
automotive_platform_msgs__msg__DriverCommands__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x44, 0x1e, 0xb0, 0x4e, 0x5e, 0xa0, 0x83, 0x60,
      0xe6, 0x0b, 0x83, 0xf7, 0xdd, 0x30, 0x4b, 0xfb,
      0x77, 0x5d, 0xda, 0x1e, 0x79, 0x47, 0x0e, 0xc6,
      0x54, 0x76, 0x97, 0x68, 0x87, 0xfe, 0xc1, 0x6d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char automotive_platform_msgs__msg__DriverCommands__TYPE_NAME[] = "automotive_platform_msgs/msg/DriverCommands";

// Define type names, field names, and default values
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__msg_counter[] = "msg_counter";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__engage[] = "engage";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__disengage[] = "disengage";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__speed_up[] = "speed_up";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__slow_down[] = "slow_down";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__further[] = "further";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__closer[] = "closer";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__right_turn[] = "right_turn";
static char automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__left_turn[] = "left_turn";

static rosidl_runtime_c__type_description__Field automotive_platform_msgs__msg__DriverCommands__FIELDS[] = {
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__msg_counter, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__engage, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__disengage, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__speed_up, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__slow_down, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__further, 7, 7},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__closer, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__right_turn, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_platform_msgs__msg__DriverCommands__FIELD_NAME__left_turn, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
automotive_platform_msgs__msg__DriverCommands__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {automotive_platform_msgs__msg__DriverCommands__TYPE_NAME, 43, 43},
      {automotive_platform_msgs__msg__DriverCommands__FIELDS, 9, 9},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Driver Commands Message\n"
  "# Contains commands from the driver to the autonomy system\n"
  "\n"
  "uint8 msg_counter   # Increments each time a command is sent\n"
  "                    # An acknowledge message should be published with this value\n"
  "\n"
  "uint16 engage       # Engage auto\n"
  "uint16 disengage    # Disengage auto\n"
  "uint16 speed_up     # Increase speed set point\n"
  "uint16 slow_down    # Decrease speed set point\n"
  "uint16 further      # Increase distance set point\n"
  "uint16 closer       # Decrease distance set point\n"
  "uint16 right_turn   # Right turn signal\n"
  "uint16 left_turn    # Left turn signal";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
automotive_platform_msgs__msg__DriverCommands__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {automotive_platform_msgs__msg__DriverCommands__TYPE_NAME, 43, 43},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 573, 573},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
automotive_platform_msgs__msg__DriverCommands__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *automotive_platform_msgs__msg__DriverCommands__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
