// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/DriverCommands.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/detail/driver_commands__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
automotive_platform_msgs__msg__DriverCommands__init(automotive_platform_msgs__msg__DriverCommands * msg)
{
  if (!msg) {
    return false;
  }
  // msg_counter
  // engage
  // disengage
  // speed_up
  // slow_down
  // further
  // closer
  // right_turn
  // left_turn
  return true;
}

void
automotive_platform_msgs__msg__DriverCommands__fini(automotive_platform_msgs__msg__DriverCommands * msg)
{
  if (!msg) {
    return;
  }
  // msg_counter
  // engage
  // disengage
  // speed_up
  // slow_down
  // further
  // closer
  // right_turn
  // left_turn
}

bool
automotive_platform_msgs__msg__DriverCommands__are_equal(const automotive_platform_msgs__msg__DriverCommands * lhs, const automotive_platform_msgs__msg__DriverCommands * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // msg_counter
  if (lhs->msg_counter != rhs->msg_counter) {
    return false;
  }
  // engage
  if (lhs->engage != rhs->engage) {
    return false;
  }
  // disengage
  if (lhs->disengage != rhs->disengage) {
    return false;
  }
  // speed_up
  if (lhs->speed_up != rhs->speed_up) {
    return false;
  }
  // slow_down
  if (lhs->slow_down != rhs->slow_down) {
    return false;
  }
  // further
  if (lhs->further != rhs->further) {
    return false;
  }
  // closer
  if (lhs->closer != rhs->closer) {
    return false;
  }
  // right_turn
  if (lhs->right_turn != rhs->right_turn) {
    return false;
  }
  // left_turn
  if (lhs->left_turn != rhs->left_turn) {
    return false;
  }
  return true;
}

bool
automotive_platform_msgs__msg__DriverCommands__copy(
  const automotive_platform_msgs__msg__DriverCommands * input,
  automotive_platform_msgs__msg__DriverCommands * output)
{
  if (!input || !output) {
    return false;
  }
  // msg_counter
  output->msg_counter = input->msg_counter;
  // engage
  output->engage = input->engage;
  // disengage
  output->disengage = input->disengage;
  // speed_up
  output->speed_up = input->speed_up;
  // slow_down
  output->slow_down = input->slow_down;
  // further
  output->further = input->further;
  // closer
  output->closer = input->closer;
  // right_turn
  output->right_turn = input->right_turn;
  // left_turn
  output->left_turn = input->left_turn;
  return true;
}

automotive_platform_msgs__msg__DriverCommands *
automotive_platform_msgs__msg__DriverCommands__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__DriverCommands * msg = (automotive_platform_msgs__msg__DriverCommands *)allocator.allocate(sizeof(automotive_platform_msgs__msg__DriverCommands), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__DriverCommands));
  bool success = automotive_platform_msgs__msg__DriverCommands__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__DriverCommands__destroy(automotive_platform_msgs__msg__DriverCommands * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_platform_msgs__msg__DriverCommands__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_platform_msgs__msg__DriverCommands__Sequence__init(automotive_platform_msgs__msg__DriverCommands__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__DriverCommands * data = NULL;

  if (size) {
    data = (automotive_platform_msgs__msg__DriverCommands *)allocator.zero_allocate(size, sizeof(automotive_platform_msgs__msg__DriverCommands), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__DriverCommands__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__DriverCommands__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__DriverCommands__Sequence__fini(automotive_platform_msgs__msg__DriverCommands__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__DriverCommands__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__DriverCommands__Sequence *
automotive_platform_msgs__msg__DriverCommands__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_platform_msgs__msg__DriverCommands__Sequence * array = (automotive_platform_msgs__msg__DriverCommands__Sequence *)allocator.allocate(sizeof(automotive_platform_msgs__msg__DriverCommands__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__DriverCommands__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__DriverCommands__Sequence__destroy(automotive_platform_msgs__msg__DriverCommands__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_platform_msgs__msg__DriverCommands__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_platform_msgs__msg__DriverCommands__Sequence__are_equal(const automotive_platform_msgs__msg__DriverCommands__Sequence * lhs, const automotive_platform_msgs__msg__DriverCommands__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_platform_msgs__msg__DriverCommands__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_platform_msgs__msg__DriverCommands__Sequence__copy(
  const automotive_platform_msgs__msg__DriverCommands__Sequence * input,
  automotive_platform_msgs__msg__DriverCommands__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_platform_msgs__msg__DriverCommands);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    automotive_platform_msgs__msg__DriverCommands * data =
      (automotive_platform_msgs__msg__DriverCommands *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_platform_msgs__msg__DriverCommands__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          automotive_platform_msgs__msg__DriverCommands__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_platform_msgs__msg__DriverCommands__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
